program Struggle;
uses
  crt,graph,CsrOnOff,graphini;
const
  versionText='1998,99   Version 2.25a';
  maxspeich=10000;                               {unkomprimierte Aktionen}
  segment=$B800;                                 {Grafik-Speicher}
var
  feld:array[-1..80, -1..25] of char;            {das Spielfeld}
  kanzahl,fanzahl,ganzahl,warte,durchgaenge:word;{(AN-Zahlen..}
  kaninchen,fuechse,gras:array[1..maxspeich]of word;{Arrays fr die Aufzeichneung}
  z,s,hoehe,breite:byte;                         {Position(Zeile, Spalte)}
  aktion,runde:longint;                          {Zhlt Aktionen, Runden}
  ende,neustart,aufzeichnen,PausVorKomp:Boolean; {Schalter}
  speichernr:integer;

procedure v(zk:string;xpos,ypos,vordergrund,hintergrund:byte);
var                   {"Schreibt" direkt in den Grafikspeicher; VORSICHT! }
 data:word;
 scrPtr:^word;
 i:byte;
begin
  scrptr:=ptr(segment,(((ypos-1)*80+xpos-1)*2));
  for i:=1 to length(zk) do
  begin
    scrptr^:=((hintergrund*16+vordergrund) shl 8+ord(zk[i]));
    inc(scrptr);
  end;
end;

procedure attribut(xpos,ypos,vordergrund,hintergrund,laenge:byte);
var
 scrPtr:^byte;
 i:byte;
begin
  scrptr:=ptr(segment,(((ypos-1)*80+xpos-1)*2));
  for i:=1 to laenge do
  begin
    inc(scrptr);
    scrptr^:=(hintergrund*16+vordergrund);
    inc(scrptr);
  end;
end;

procedure wiederherstellen;{Verteilt alle Kaninchen und Fuechse auf dem Screen}
var hilfstr:string[8];
begin
  clrscr;
  for z:= 0 to (hoehe-1) do
    for s:= 0 to (breite-1) do
      case feld[s,z] of
        'G':word(ptr(segment,(((z)*80+s)*2))^):=$2747; {G}
        'k':word(ptr(segment,(((z)*80+s)*2))^):=$076B; {k}
        'f':word(ptr(segment,(((z)*80+s)*2))^):=$0766; {f}
        'K':word(ptr(segment,(((z)*80+s)*2))^):=$174B; {K}
        'F':word(ptr(segment,(((z)*80+s)*2))^):=$4746; {F}
       else word(ptr(segment,(((z)*80+s)*2))^):=$0700; { }
      end;
  str(runde:8,hilfstr);
  v(hilfstr+'. Runde  ',62,13,7,0);
  str((hoehe*breite-ganzahl-kanzahl-fanzahl):4,hilfstr);
  v(hilfstr+' leere Felder',62,5,7,0);
  str(aktion:6,hilfstr);
  v(hilfstr+'. Aktion ',63,3,7,0);
  inc(aktion);
  str(ganzahl:4,hilfstr);
  v(hilfstr+' Grser ',63,7,7,green);
  str(kanzahl:4,hilfstr);
  v(hilfstr+' Kaninchen ',62,9,7,blue);
  str(fanzahl:4,hilfstr);
  v(hilfstr+' Fchse ',63,11,7,red);
end;   {procedure wiederherstellen}

procedure pause(lang:boolean); {Wenn Tastendruck, dann Pause}
  const vg=lightgray;
  var
    i:word;
    ch:char;
    xpos,ypos,hg:byte;
    code:integer;
    rundestr:string[8];
    wartestr:string[4];
  procedure kurven;            {Graphen zeichnen}
  var
    i,maxx,maxy,altgras,altkan,altfuchs:word;
    xsprung,ysprung:real;
    hilfstr:string[8];
    dickte:byte; {...der Linien}
  begin
    if graphinit('egavga',2) then
      begin
        dickte:=1;
        maxx:=getmaxx; maxy:=getmaxy;
        xsprung:=speichernr/maxx;
        ysprung:=maxy/(hoehe*breite);
        repeat
         setcolor(white);
         if maxx>320 then settextstyle(1,0,5) else settextstyle(0,0,1);
         outtextxy((maxx div 4),10,'S T R U G G L E !');
         setlinestyle(0,0,dickte);
         i:=1;
         altgras:=gras[i]; altkan:=kaninchen[i]; altfuchs:=fuechse[i];
         repeat
          inc(i);
          setcolor(green);
          line((i-1),maxy-round(ysprung*altgras),i,maxy-round(ysprung*gras[round(i*xsprung)]));
          altgras:=gras[round(i*xsprung)];
          setcolor(blue);
          line((i-1),maxy-round(ysprung*altkan),i,maxy-round(ysprung*kaninchen[round(i*xsprung)]));
          altkan:=kaninchen[round(i*xsprung)];
          setcolor(red);
          line((i-1),maxy-round(ysprung*altfuchs),i,maxy-round(ysprung*fuechse[round(i*xsprung)]));
          altfuchs:=fuechse[round(i*xsprung)];
          delay(round(warte*(13/maxx)));
         until (keypressed or(i=maxx));
         ch:=readkey;
         case ch of
           'g': if dickte=1 then dickte:=3 else begin
                  clearviewport; dickte:=1; end;
           'i': begin setcolor(white); graphinfo(maxx div 64,maxy div 46); end;
           'r': neustart:=true;
           char(27): begin ende:=true; neustart:=true end;
         end;
        until ((ch<>'g')and(ch<>'i'));
        closegraph; csroff;
        if not neustart then
          begin
            wiederherstellen;
            pause(lang);
          end;
      end;
  end;       {procedure kurven}
  procedure readme_lesen;
    const vgl= blue;
    var
      datei:text;
      line:string[78];
      i,j:byte;
    begin
      assign(datei,'readme.txt');
      {$I-}reset(datei);{$I+}
      if ioresult = 0 then
        begin
         hg:=lightgray;
         for i:=2 to 79 do v('',i,1,vgl,hg);
         v('',1,1,vgl,hg); v('',80,1,vgl,hg);
         for i:=2 to 24 do
          begin
           line:='';
           v('',1,i,vgl,hg);
           if not eof(datei) then readln(datei,line);
           v(line,2,i,vgl,hg);
           if not keypressed then delay(100);
           if length(line)>1 then for j:=(length(line)+2) to 79 do v(' ',j,i,vgl,hg)
            else for j:=2 to 79 do v(' ',j,i,vgl,hg);
           v('',80,i,vgl,hg);
          end;
          for i:=2 to 79 do v('',i,25,vgl,hg);
          v('',1,25,vgl,hg); v('',80,25,vgl,hg);
          v('Readme.txt',3,1,vgl,hg);
          close(datei); ch:=readkey;
         end
        else
         begin
           clrscr; writeln('Datei readme.txt nicht gefunden!'); ch:=readkey;
         end;
      ch:='l';
    end;  {procedure readme_lesen}
begin        {procedure pause}
  if lang then
  begin
    xpos:=30; ypos:=8;
    for i:=1 to 25 do attribut(1,i,lightblue,blue,80);
  end
  else
  begin
    xpos:=63; ypos:=13;
  end;
  hg:=magenta;
  str(runde:8,rundestr);
  v('ͻ',xpos,ypos,vg,hg);
  v(' Runde '+rundestr+' ',xpos,ypos+1,vg,hg);
  v(' l=readme lesen ',xpos,ypos+2,vg,hg);
  v('g=Graph zeichnen',xpos,ypos+3,vg,hg);
  v('  n=Graph Neu   ',xpos,ypos+4,vg,hg);
  v(' v=Verzgerung  ',xpos,ypos+5,vg,hg);
  v('͹',xpos,ypos+6,vg,hg);
  v('r=reset esc=ende',xpos,ypos+7,vg,hg);
  v('ͼ',xpos,ypos+8,vg,hg);
  repeat
  ch:=readkey;
  case ch of
    'v': begin
           csron; textbackground(hg);
           v('(0-3000):    ',xpos+2,ypos+6,vg,hg);
           gotoxy(xpos+11,ypos+6);
           readln(wartestr);
           val(wartestr,warte,code); if code<>0 then warte:=0;
           if warte>3000 then warte:=3000;
           csroff; textbackground(black);
         end;
    char(27): begin ende:=true; neustart:=true; end;
    'r': neustart:=true;
    'l': readme_lesen;
    'g': kurven;
    'n': begin
           durchgaenge:=1;
           speichernr:=0;
           aktion:=0;
           v('Daten gelscht!',xpos+1,ypos+6,vg,hg);
         end;
   end;
  until (ch<>'n');
  if ((ch='l')or(warte<>88)or lang) then wiederherstellen;
end; {von procedure pause}

procedure auswertung(text:string;farbe:byte);  {Zaehlt, merkt, wertet aus...}
var
  i:word;
  sstr,zstr:string[2];
  hilfstr:string[8];
begin
  str(s:2,sstr);
  str(z:2,zstr);
  v(text,62,23,7,farbe);
  v('   ..auf '+sstr+'/'+zstr+'!   ',62,24,7,farbe);
  str(runde:8,hilfstr);
  v(hilfstr+'. Runde  ',62,13,7,0);
  str((hoehe*breite-ganzahl-kanzahl-fanzahl):4,hilfstr);
  v(hilfstr,62,5,7,0);
  str(aktion:6,hilfstr);
  v(hilfstr,63,3,7,0);
  inc(aktion);
  str(ganzahl:4,hilfstr);
  v(hilfstr,63,7,7,green);
  str(kanzahl:4,hilfstr);
  v(hilfstr,62,9,7,blue);
  str(fanzahl:4,hilfstr);
  v(hilfstr,63,11,7,red);
  if aufzeichnen then
   if (aktion mod durchgaenge = 0) then
    begin
      inc(speichernr);
      gras[speichernr]:=ganzahl;
      kaninchen[speichernr]:=kanzahl;
      fuechse[speichernr]:=fanzahl;
      if (speichernr=maxspeich) then
        begin
          if PausVorKomp then pause(true);
          if speichernr>0 then
           begin
            v('Komprimieren',62,3,7,4);
            for i:=1 to (maxspeich div 2) do
             begin
              if (i mod 1000 = 0) then v('.',73+(i div 1000),3,7,4);
              gras[i]:=gras[i*2];
              kaninchen[i]:=kaninchen[i*2];
              fuechse[i]:=fuechse[i*2];
             end;
            v('       . Aktion   ',62,3,7,0);
            speichernr:=(maxspeich div 2);
            durchgaenge:=durchgaenge*2;
           end;
        end;
   end;
end;   {von auswertung}

function init:boolean; {Initialisiert, was sonst..}
var
  i,j,tips:byte;
  soll:word;
  ch:char;
  procedure tip;
  var i:byte;
  begin
   for i:=1 to 80 do v(' ',i,14,0,0);
   case tips of
    0:begin v('Tip-of-the-day:',1,14,15,0);v('Verzgerung 88 bewirkt eine Pause nach jeder Aktion!!',17,14,7,0); end;
    1:begin v('Tip-des-Tages:',1,14,15,0);v('Schalter ''p'' und ''a''! Einfach sofort mal drcken...!',16,14,7,0); end;
    2:begin v('TIP: ',1,14,15,0);v('Schon 6x>Eingabe< reicht fr einen Durchlauf mit den Voreinstellungen..',6,14,7,0); end;
    3:begin v('Info:',1,14,15,0);v('Ab STRUGGLE 1.10 gibt''s Reset(''r''), ab 2.00 Kurven(''g'')!',7,14,7,0); end;
    4:begin v('Tips durchsehen:',1,14,15,0);v('Ab STRUGGLE 1.21. Einfach irgendeine Taste drcken...',18,14,7,0); end;
    5:begin v('Noch schneller!!',1,14,15,0);v('Bei Breiten >60 entfllt die Auswertung ganz.',18,14,7,0); end;
    6:begin v('Noch was:',1,14,15,0);v('Verzgerung ndern mit ''+-''(im Spiel) oder ''v''(in der Pause)!',11,14,7,0); end;
    7:begin v('Schon gewusst?',1,14,15,0);v('Die Verzgerung beinflusst auch das Zeichen der Verlaufskurven!',16,14,7,0);end;
    8:begin v('NEU:',1,14,15,0);v('1.Grafikmodus bestimmen mit Kommandozeilenparameter '+
               '2.''g,i'' im Grafikmodus!',6,14,7,0); end;
   end;
   if tips=8 then tips:=0 else inc(tips);
  end; {von procedure tip}
  procedure Schalter(welcher:char);
  var i:byte;
  begin
    for i:=1 to 80 do v(' ',i,10,7,0);
    case welcher of
    'a':begin
          aufzeichnen:=not aufzeichnen;
          if aufzeichnen then v('Aufzeichnung eingeschaltet',15,10,15,0)
                         else v('Aufzeichnung ausgeschaltet',15,10,15,0);
        end;
    'p':begin
          PausVorKomp:=not PausVorKomp;
          if PausVorKomp then
            v('Pause vor Komprimieren(=Datenverlust) an',15,10,15,0)
            else v('Pause vor Komprimieren(=Datenverlust) aus',15,10,15,0);
        end;
    's':v('Diesen Schalter gibt''s nicht mehr!',15,10,15,0);
    end;
  end;  {von procedure Schalter}
  procedure Eingabe(var ergebniss:word;links,rechts,auto:word);
  var
    eingabe:string;
    code:integer;
    ch:char;
  begin  {procedure Eingabe}
    eingabe:='';
    repeat
      ch:=readkey;
      if (ch='P')or(ch='H')or(ch='K')or(ch='M') then ch:=readkey;
      case ch of
        '0'..'9': begin
                    eingabe:=eingabe+ch; write(ch);
                  end;
        chr(8):   begin
                    if length(eingabe) > 0 then gotoxy(wherex-1,wherey);
                    delete(eingabe,length(eingabe),1);
                    write(' '); gotoxy(wherex-1,wherey);
                  end;
        chr(27):  begin ende:=true; neustart:=true; end;
        'r':      neustart:=true;
        'a':      Schalter('a');
        'p':      Schalter('p');
        's':      Schalter('s');
        else if not(ord(ch)=13) then tip;
      end
    until ((ord(ch)=13)or neustart);
    if eingabe='' then
      begin
        ergebniss:=auto;
        write(' ',ergebniss);
      end
    else
      begin
        val(eingabe,ergebniss,code);
        if not((links<=ergebniss)and(ergebniss<=rechts))then ergebniss:=auto;
      end;
  writeln;
  end; {von eingabe}
  procedure verteile(buchstabe:char;anzahl:word);
  begin
   while anzahl>0 do
     begin
      s:=random(breite); z:=random(hoehe);
      if feld[s,z]=' ' then
        begin
          feld[s,z]:=buchstabe;
          dec(anzahl);
        end;
     end;
  end; {von verteilen}
begin  {von init}
  clrscr; writeln(^j,' S T R U G G L E !                  ...von Vlado Plaga  ', versionText);
  writeln(^j,'STRUGGLE ist kein Spiel- sondern der ultimative Wiesensimulator. Die Regeln:');
  write('Jede Runde wird ein Feld "gewrfelt". Der Inhalt wird folgendermassen verndert:');
  writeln(' -Auf leeren Feldern (auch tote Tiere) wchst immer Gras');
  writeln(' -Gras wird von Kaninchen gefressen, wenn welche auf einem Nebenfeld sind');
  writeln(' -Kanichen werden von Fchsen gefressen und verhungern ohne Gras in der Nhe');
  writeln(' -Fchse verhungern, wenn es auf den Nachbarfeldern keine Kaninchen gibt');
  writeln(^j,'Auf einem Feld, das allen Arten Lebensraum bietet, stellt sich ein natrliches');
  writeln('Gleichgewicht ein, das nur durch den Menschen (Esc) gestrt werden kann..');
  randomize;
  runde:=0; aktion:=0; durchgaenge:=1; speichernr:=0;
  tips:=random(9); tip;
  writeln(^j,^j,^j, 'Die Einstellungen:');
  write(^j,'Verzgerung in Millisekunden (bis 3000, auto=',warte,'): ');
  eingabe(warte,0,3000,warte);
  write(^j,'Wie breit soll das Feld sein(1-80, auto=',breite,')? ');
  if not neustart then eingabe(soll,1,80,breite); breite:=soll;
  write('...und wie hoch(1-25, auto=',hoehe,')? ');
  if not neustart then eingabe(soll,1,25,hoehe); hoehe:=soll;
  write(^j,'Graswuchs(0-',breite*hoehe-1,', auto=',(breite * hoehe) div 4 +1,')? ');
  if not neustart then
    eingabe(ganzahl,0,(breite*hoehe-1),((breite * hoehe) div 4 +1));
  write('Wieviele Kaninchen(0-',breite*hoehe-ganzahl,', auto=', (hoehe*breite-ganzahl) div 3,')? ');
  if not neustart then eingabe(kanzahl,0,(breite*hoehe-ganzahl),((hoehe*breite-ganzahl) div 3));
  write('Jetzt noch die Fchse(0-',breite*hoehe-kanzahl-ganzahl,', auto=', (hoehe*breite-ganzahl-kanzahl) div 5,')... ');
  if not neustart then eingabe(fanzahl,0,(breite*hoehe-ganzahl-kanzahl),((hoehe*breite-ganzahl-kanzahl) div 5));
  if not neustart then
  begin
   for i:=0 to 81 do
     for j:=0 to 26 do feld[(i-1),(j-1)]:=' ';
   verteile('G',ganzahl);  {Feld initialisieren}
   verteile('K',kanzahl);
   verteile('F',fanzahl);
   wiederherstellen;
   gotoxy(65,24);
   v('Go!',62,24,143,4);
   ch:=readkey;
  end;
  if ((ch='r')or(ord(ch)=27)or neustart)then init:=false else init:=true;
  csroff;
end;     {von init}

procedure spiel;          {Der Kern des Spiels, wendet die Regeln an}
 procedure schreibe(buchstabe:char;text:string;farbe:byte);
 begin
  feld[s,z]:=buchstabe;
  if breite <= 60 then auswertung(text,farbe);
    if warte > 0 then
      begin
        word(ptr(segment,(((z)*80+s)*2))^):=((farbe*16+143) shl 8+ord(buchstabe));
        if warte=88 then pause(false) else delay(warte);
      end;
  word(ptr(segment,(((z)*80+s)*2))^):=((farbe*16+7) shl 8+ord(buchstabe));
 end;
begin
  s:=random(breite); z:=random(hoehe);
  case feld[s,z] of
   ' ','f','k':begin                         {leeres Feld getroffen}
                inc(ganzahl);
                schreibe('G','Gras gewachsen... ',green);
               end;
   'G':begin                                 {Gras getroffen}
        if ((feld[s,z+1]='K')or(feld[s,z-1]='K')or(feld[s+1,z]='K')or(feld[s-1,z]='K'))then
         begin
           inc(kanzahl);
           dec(ganzahl);
           schreibe('K','Gras gefressen... ',blue);
         end;
       end;
   'K':begin                                 {Kaninchen getroffen}
        if ((feld[s,z+1]='F')or(feld[s,z-1]='F')or(feld[s+1,z]='F')or(feld[s-1,z]='F'))then
         begin
           inc(fanzahl);
           dec(kanzahl);
           schreibe('F','Kaninchen tot...  ',red);
         end
       else
         if not((feld[s,z+1]='G')or(feld[s,z-1]='G')or(feld[s+1,z]='G')or(feld[s-1,z]='G'))then
           begin
             dec(kanzahl);
             schreibe('k','Kaninchen tot...  ',black);
           end;
     end;
   'F': if not((feld[s,z+1]='K')or(feld[s,z-1]='K')or(feld[s+1,z]='K')or(feld[s-1,z]='K'))then
         begin                               {Fuchs getroffen}
           dec(fanzahl);
           schreibe('f','Fuchs verhungert..',black);
         end;
  end;     {of case}
end; {von procedure spiel}

procedure main;  {Hier laeuft die Haupt(while)Schleife}
var
  ch:char;
  wartestr:string[4];
begin
  ende:=false; aufzeichnen:=true; PausVorKomp:=false;
  warte:=0; breite:=60; hoehe:=25;
  while not ende do
   begin
    neustart:=false;
    if init then
      while not neustart do
        begin
          inc(runde);
          spiel;
          if keypressed then
            begin
              ch:=readkey;
              case ch of
                'r': neustart:=true;
                char(27): begin neustart:=true; ende:=true; end;
                '+':begin
                     if warte<3000 then inc(warte);if warte=88 then inc(warte);
                     str(warte:4,wartestr);
                     v('Verzgerung: '+wartestr,62,15,7,0);
                    end;
                '-':begin
                     if warte>0 then dec(warte);if warte=88 then dec(warte);
                     str(warte:4,wartestr);
                     v('Verzgerung: '+wartestr,62,15,7,0);
                    end;
                else pause(true);
              end;
            end;
        end; {von while not neustart}
     csrON;
   end; {while not ende}
end; {von procedure main}

begin
  main;
  clrscr;
  writeln('t h e   S T R U G G L E   c o n t i n u e s . . .');
end.